function h = hotmy(m)
%HOT    Black-red-yellow-white color map
%   HOTMY(M) returns an M-by-3 matrix containing a "hot" colormap.
%   HOTMY, by itself, is the same length as the current figure's
%   colormap. If no figure exists, MATLAB creates one.
%
%   For example, to reset the colormap of the current figure:
%
%             colormap(hotmy)
%
%   See also HSV, GRAY, PINK, COOL, BONE, COPPER, FLAG, 
%   COLORMAP, RGBPLOT.

if nargin < 1, m = size(get(gcf,'colormap'),1); end
n = fix(1/2*m);

r = [(1:n)'/n; ones(m-n,1)];
g = [zeros(n,1); (1:n)'/n];
b = zeros(m,1);

h = [r g b];
